#pragma once


#include "MeshLoader.h"


template<uint8_t DIM>
class AneuMeshLoader : public MeshLoader<DIM>
{
public:
	virtual void loadMesh(const std::string& filename) override
	{
		std::ifstream file(filename);
		
		uint16_t node_cnt,	//amount of nodes 
				 fe_cnt,	//amount of finite elements
				 bfe_cnt;   //amount of boundary finite elements
		uint8_t	 dim,			//space dimension
				 fe_vertex_cnt, //amount of finite element vertexes
				 bfe_vertex_cnt; //amount of boundary finite element vertexes
		
		Node<DIM> cur_node;
		FiniteElement cur_fe;
		BoundaryFiniteElement cur_bfe;


		if (!file.is_open())
		{
			throw FileExc();
		}

		//First parsing(nodes)
		file >> node_cnt >> dim;
		for (uint32_t i = 1; i <= node_cnt; ++i)
		{
			cur_node.id = i;
			file >> cur_node;
            // ПРЕФИКС В ВИДЕ КЛАССА УКАЗЫВАТЬ НЕОБЯЗАТЕЛЬНО (ЭТО ЛИШНЕЕ НАГРАМОЖДЕНИЕ),
            // ВЕДЬ В КЛАССЕ AneuMeshLoader НЕТ ТАКОЙ ФУНКЦИИ,
            // А ЗНАЧИТ И ПУТАНИЦЫ НЕТ: БУДЕТ ВЫЗВАНА ФУНКЦИЯ ИЗ
            // БАЗОВОГО КЛАССА
			MeshLoader<DIM>::AddNode(cur_node);
		}
		

		//Second parsing(finite elements)
		file >> fe_cnt >> fe_vertex_cnt;
		for (uint32_t i = 1; i <= fe_cnt; ++i)
		{
			cur_fe.id = i;
			file >> cur_fe;
			MeshLoader<DIM>::AddFE(cur_fe);
			
			//We assign all FE nodes as inner, later(in BFE processing) we change some of them
			for (uint8_t j = 0; j < cur_fe.nodes.size(); ++j)
			{
				MeshLoader<DIM>::getNodeWithID(cur_fe.nodes[j]).in_node = true;
			}
		}


		//Third parsing(boundary finite elements)
		file >> bfe_cnt >> bfe_vertex_cnt;
		for (uint32_t i = 1; i <= bfe_cnt; ++i)
		{
			cur_bfe.id = i;
			file >> cur_bfe;
			MeshLoader<DIM>::AddBFE(cur_bfe.boundary_id, cur_bfe);

			//BFE nodes are not inner
			for (uint8_t j = 0; j < cur_bfe.nodes.size(); ++j)
			{
				MeshLoader<DIM>::getNodeWithID(cur_bfe.nodes[j]).in_node = false;
			}
		}
	}
};
