#pragma once


#include <iostream>


class FileExc : public std::exception
{
protected:
	std::string str;

public:
	FileExc();

	virtual const char* what() const override;
};

class MeshLoaderMethodsExc : public std::exception
{
protected:
	std::string str;

public:
	virtual const char* what() const = 0;
};

class EmptyBufferExc final : public MeshLoaderMethodsExc
{
public:
	EmptyBufferExc();
	
	EmptyBufferExc(std::string _str);

	virtual const char* what() const override;
};


class NodeWrongIDExc final : public MeshLoaderMethodsExc
{
public:
	NodeWrongIDExc();

	NodeWrongIDExc(std::string _str);

	virtual const char* what() const override;
};